﻿using MurlocBuddy.DataBase;
using MurlocBuddy.MLua;
using MurlocBuddy.Objects;
using Styx.Common;
using System.Collections.Generic;
using System.Linq;
using MurlocBuddy;

namespace MurlocBuddy.Core
{
    public static class LogicValuer
    {
        static List<ActionRatio> ActionRatioList = new List<ActionRatio>();

        static List<ActionRatio> SortedActionRatioList = new List<ActionRatio>();

        static ActionRatio aRatio = new ActionRatio();

        static double Ratio;

        public static PetAction GetActionValue()
        {
         
            Pet MyPet = new Pet(1, C_PetBattles.GetActivePet(1));
            Pet EnemyPet = new Pet(2, C_PetBattles.GetActivePet(2));

        

            AbilityValuer(MyPet, EnemyPet);

            SwapValuer(MyPet);

            PassValuer(MyPet);

            TrapValuer(EnemyPet);

            SortedActionRatioList = ActionRatioList.OrderByDescending(o => o.value).ToList();

            if (SortedActionRatioList.Count == 0) return PetAction.None;

            Logging.Write("[LogicValuer] Return " + SortedActionRatioList[0].index);
            return (PetAction)SortedActionRatioList[0].index;
        }

        static void AbilityValuer(Pet MyPet, Pet EnemyPet)
        {
            ActionRatioList.Clear();
            SortedActionRatioList.Clear();
            Ratio = 0.0;
            foreach (Ability a in MyPet.ability())
            {
                if (!a.isUsable) continue;
                AbilityTable.AbilityRow ability = db.abilityTable.FindById(a.id);
   
                if (ability == null)
                {
                    Logging.Write("Ability "+ a.name +" not in base, missing... ");
                    continue;
                }
           
                Ratio = 0.0;
                double ModifierDamage = C_PetBattles.GetAttackModifier(C_PetBattles.GetAbilityInfoByID((int)ability.Id).petType, EnemyPet.Type);

                switch ((FuncType)ability.FunctionType)
                {
                    case FuncType.NormalDamage:
                        Ratio += NormalDamage(MyPet, EnemyPet, ability.BaseDamage, ability.Hit, ability.NumAoe, ModifierDamage, ability.AlwaysFirstMove);
                        break;

                    case FuncType.AvoidAttack:
                        Ratio += AvoidAttack(Ratio, MyPet, EnemyPet, ability.AuraId);
                        break;

                    default:
                        break;
                }

                if (ability.SecondAttack)
                    switch ((FuncType)ability.secondFunctionType)
                    {
                               
                        case FuncType.NormalDamage:
                            Ratio += NormalDamage(MyPet, EnemyPet, ability.secondBaseDamage, ability.secondHit, ability.NumAoe, ModifierDamage, ability.AlwaysFirstMove);
                            break;
                        case FuncType.SpeedUp:
                            Ratio += SpeedUp(Ratio, MyPet, EnemyPet, ability.AuraId, ability.BaseDamage);
                            break;
                        case FuncType.OpponentIsSlower_PassTurn:
                            Ratio += OpponentIsSlower_PassTurn(Ratio, MyPet.Speed, EnemyPet.Speed, ability.secondHit);
                            break;
                        case FuncType.SlowingEnemy:
                            Ratio += SlowingEnemy(Ratio, MyPet.Speed, EnemyPet.Speed, ability.secondHit, ability.secondBaseDamage);
                            break;

                        case FuncType.DamageReduction:
                            Ratio += DamageReduction(EnemyPet, Ratio, ability.secondAuraId, ability.secondHit, ability.secondBaseDamage, ability.secondTurnOn);
                            break;

                        case FuncType.StunEnemy:
                            Ratio += DamageReduction(EnemyPet, Ratio, ability.secondAuraId, ability.secondHit, ability.secondBaseDamage, ability.secondTurnOn);
                            break;
                        case FuncType.DamageOverTime:
                            Ratio += DamageOverTime(MyPet, EnemyPet, ability.secondBaseDamage, ability.secondHit, 1, ModifierDamage, ability.secondAuraId, ability.secondTurnOn);
                            break;

                        default:
                            break;


                    }


                aRatio.value = Ratio;
                aRatio.index = a.spellIndex;

                Logging.Write("Spell " + aRatio.index + "Ratio " + aRatio.value);

                ActionRatioList.Add(aRatio);

            }


        }

        static void SwapValuer(Pet myPet)
        {
            int petCounter = 0;
            int petDieCounter = 0;

                for (int x = 1; x <= MLua.C_PetBattles.GetNumPets(1); x++)
                {
                    Pet pet = new Pet(1, x);
                    if (pet.HealthPercent < 30) petCounter++;
                        if (pet.HealthPercent <= 0) petDieCounter++;
                }
                Logging.Write("MLua.C_PetBattles.GetNumPets(1) = " + MLua.C_PetBattles.GetNumPets(1));
                if (petDieCounter == MLua.C_PetBattles.GetNumPets(1)) return;

            if (myPet.HealthPercent < 0)
            {
                Logging.Write("Is dead, petDieCounter!petDieCounter " + petDieCounter);
                Logging.Write("Is dead, NeedSwitch!");
                aRatio.value = 9999;
                aRatio.index = 4;
                ActionRatioList.Add(aRatio);
                return;
            }

            else if (myPet.HealthPercent < 30)
            {
                Logging.Write("Is dead, petDieCounter! petCounter = " + petCounter);
                Logging.Write("MLua.C_PetBattles.GetNumPets(1) = " + MLua.C_PetBattles.GetNumPets(1));
                if (petCounter == MLua.C_PetBattles.GetNumPets(1)) { return; }
                
                    Logging.Write("NeedSwitch!");
                    aRatio.value = 1500;
                    aRatio.index = 4;
                    ActionRatioList.Add(aRatio);
                    
                
            }
        }

        static void PassValuer(Pet myPet)
        {
            foreach (var aura in myPet.aura())
            {
                if (db.auraTable.FindById(aura.auraID) != null) 
                if ((AuraEffect)db.auraTable.FindById(aura.auraID).Effect == AuraEffect.Root)
                {
                    Logging.Write("Need pass!");
                    aRatio.value = 1;
                    aRatio.index = 0;
                    ActionRatioList.Add(aRatio);
                    return;
                }
            }



        }

        static void TrapValuer(Pet enemy)
        {
    
            if(enemy.Quality == BattlePetQuality.Rare && C_PetBattles.IsTrapAvailable())
            {
                Logging.Write("Need Trap!");
                aRatio.value = 7000;
                aRatio.index = 5;
                ActionRatioList.Add(aRatio);
                return;
            }


        }


        static double AbilityDamage(double baseDamage, double attackPower)
        {
            double abilityDamage = baseDamage * ((attackPower + 20) / 20);
            return abilityDamage;
        }

        static double DamageFactor(double actualDamage, int lvl)
        {
            double damageFactor = actualDamage * 01 / lvl;
            return damageFactor;
        }

        static double NormalDamage(Pet myPet, Pet enemy, int baseDamage, double hit, int numAoe, double modifer, bool alwaysFirstMove)
        {
            double ratio = 0.0;
            double abilityDamage = AbilityDamage(baseDamage, myPet.Power) * hit * numAoe;
            double actualDamage = abilityDamage * modifer;

            ratio = DamageFactor(actualDamage, myPet.Level);
            if (alwaysFirstMove && myPet.Speed < enemy.Speed) ratio += ratio * 0.25;
            if ((enemy.Health - actualDamage) <= 0) ratio = 1000;
            if ((enemy.Health - actualDamage) <= 0 && (alwaysFirstMove || myPet.Speed > enemy.Speed)) ratio = 2000;

            return ratio;
        }

        static double DamageOverTime(Pet myPet, Pet enemy, int baseDamage, double hit, int numAoe, double modifer, int dotId, int turnOn)
        {
          
            if (enemy.HasAuraId(dotId)) return 2;

            double abilityDamage = AbilityDamage(baseDamage, myPet.Power) * hit * numAoe * turnOn;
            double actualDamage = abilityDamage * modifer;
            double ratio = DamageFactor(actualDamage, myPet.Level);

            return ratio;
        }

        static double SpeedUp(double ratio, Pet myPet, Pet enemy, int auraId, int damage)
        {

            if (myPet.HasAuraId(auraId)) ratio =  0.0;
            if (myPet.Speed < enemy.Speed && (myPet.Speed * (damage * 0.01) + myPet.Speed) > enemy.Speed) ratio += ratio * 0.25;

         return ratio;
    
        }

        static double StunEnemy(double ratio, double abilityHit)
        {
            return ratio * abilityHit * 0.01;
        }
        //static double DamageReduces()
        //{

        //}

        static double AvoidAttack(double ratio, Pet myPet, Pet enemy, int auraId)
        {

            foreach (var aura in enemy.aura())
            {
                if (db.auraTable.FindById(aura.auraID) != null) 
                if ((AuraEffect)db.auraTable.FindById(aura.auraID).Effect == AuraEffect.Damage)
                {
                    return 5000;
                }
            }
            return 0.0;

        }



        static double SlowingEnemy(double ratio, int mySpeed, int enemySpeed, double abilityHit, double abilityDamage)
        {
            if (mySpeed < enemySpeed && mySpeed > (enemySpeed - enemySpeed * abilityDamage)) ratio += ratio * abilityHit * 0.25;
            return ratio;
        }

        static double DamageReduction(Pet enemy, double ratio, int auraId, double abilityHit, double abilityDamage, int inRounds)
        {
            if (enemy.HasAuraId(auraId)) return 0;
            Logging.Write(enemy.HasAuraId(auraId) + "Id " + auraId);
            ratio = ratio * abilityHit * (abilityDamage * 0.01) * 2 * inRounds;

            return ratio;
        }





        static double OpponentIsSlower_PassTurn(double ratio, int mySpeed, int enemySpeed, double abilityHit)
        {
            if (mySpeed > enemySpeed) ratio += ratio * abilityHit;
            return ratio;
        }

    }





    struct ActionRatio
    {
        public int index;
        public double value;
    }
}
