﻿using MurlocBuddy.MLua;
using MurlocBuddy.Objects;
using System.Collections.Generic;
using System.Linq;

namespace MurlocBuddy.Core
{
   public class Swap
    {

       internal static void Pulse(int healStep = 30)
       {
             Pet enemyPet = new Pet(2, C_PetBattles.GetActivePet(2));
             List<petFilter> lpFilter = new List<petFilter>();
             List<petFilter> SortedList;

             for (int x = 1; x <= 3; x++)
             {
                 Pet myPet = new Pet(1, x);
                 if (myPet.HealthPercent <= healStep) { continue; }


                 double Ratio = 0.0;

                 Ratio += GetAbilityRatio(myPet.ability(), enemyPet.Type);
                 Ratio += GetSpeedRatio(myPet.Speed, enemyPet.Speed);
                 Ratio += GetHealRatio(myPet.Health, myPet.MaxHealth);
                 Ratio += GetPositionRatio(x);
                 Ratio -= GetAbilityRatio(enemyPet.ability(), myPet.Type);


                 petFilter pFil = new petFilter();
                 pFil.Index = x;
                 pFil.Value = Ratio;
                 lpFilter.Add(pFil);
             }

             SortedList = lpFilter.OrderByDescending(o => o.Value).ToList();

             if (SortedList.Count == 0) { Swap.Pulse(0); return; }

             C_PetBattles.ChangePet(SortedList[0].Index);
       }


       static double GetAbilityRatio(List<Ability> lAbility, int enemyType)
       {
           double ratio = 0.0;
           foreach (Ability a in lAbility)
           {
               if (a.id == 0) continue;

               if (a.noStrongWeakHints)
               {
                   ratio += 1;
               }
               else
               {
                   ratio += C_PetBattles.GetAttackModifier(a.petType, enemyType);
               }
           }
           return ratio;
       }
       static double GetSpeedRatio(int mySpeed, int enemySpeed)
       {
           if (mySpeed > enemySpeed) return 0.5;
           return 0;
       }
       static double GetHealRatio(int curHeal, int maxHeal)
       {
           double result = curHeal / maxHeal;
           return result;
       }
       static double GetPositionRatio(int petIndex)
       {
           if (C_PetBattles.GetActivePet(1) == petIndex) return 0.5;
           return 0.0;
       }

       struct petFilter
       {
           public int Index;
           public double Value;
       }
    }
}
