﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data;

namespace MurlocBuddy.DataBase
{
    public class AbilityTable : DataTable
    {

        public AbilityTable()
        {


            TableName = "PetAbility";

            DataColumn Id = new DataColumn
            {
                ColumnName = "Id",
                DataType = typeof(int),   // Default string
                Unique = true,                     // Default false
                AllowDBNull = false,            // Default true
                Caption = "Id"         // Default is constructor value
            };
            Columns.Add(Id);

            PrimaryKey = new DataColumn[] { Id };

            Columns.Add(new DataColumn("Name", typeof(string)));
            Columns.Add(new DataColumn("AuraId", typeof(int)));
            Columns.Add(new DataColumn("BaseDamage", typeof(int)));


            Columns.Add(new DataColumn("Hit", typeof(double)));


            Columns.Add(new DataColumn("NumAoe", typeof(int)));


            Columns.Add(new DataColumn("TurnToActive", typeof(int)));

            Columns.Add(new DataColumn("TurnOn", typeof(int)));

            Columns.Add(new DataColumn("FunctionType", typeof(int)));



            Columns.Add(new DataColumn("AlwaysFirstMove", typeof(bool)));



            Columns.Add(new DataColumn("WeatherTurns", typeof(int)));



            Columns.Add(new DataColumn("SecondAttack", typeof(bool)));



            Columns.Add(new DataColumn("secondBaseDamage", typeof(int)));


            Columns.Add(new DataColumn("secondAuraId", typeof(int)));


            Columns.Add(new DataColumn("secondHit", typeof(double)));


            Columns.Add(new DataColumn("secondTurnToActive", typeof(int)));


            Columns.Add(new DataColumn("secondFunctionType", typeof(int)));


            Columns.Add(new DataColumn("secondTurnOn", typeof(int)));





        }


        public AbilityRow FindById(int Id)
        {
            return ((AbilityRow)(this.Rows.Find(new object[] {
                            Id})));
        }


        protected override Type GetRowType()
        {
            return typeof(AbilityRow);
        }

        protected override DataRow NewRowFromBuilder(DataRowBuilder builder)
        {
            return new AbilityRow(builder);
        }

        public class AbilityRow : DataRow
        {
            internal AbilityRow(DataRowBuilder builder)
                : base(builder)
            {
                Id = 0;
                Name = String.Empty;
                AuraId = 0;
                BaseDamage = 0;
                Hit = 0.0;
                NumAoe = 1;
                TurnToActive = 0;
                TurnOn = 1;
                FunctionType = 0;
                AlwaysFirstMove = false;
                WeatherTurns = 0;
                SecondAttack = false;
                secondBaseDamage = 0;
                secondAuraId = 0;
                secondHit = 0.0;
                secondTurnToActive = 0;
                secondFunctionType = 0;
                secondTurnOn = 1;
            }

            public int Id
            {
                get { return (int)base["Id"]; }
                set { base["Id"] = value; }
            }

            public string Name
            {
                get { return (string)base["Name"]; }
                set { base["Name"] = value; }
            }

            public int AuraId
            {
                get { return (int)base["AuraId"]; }
                set { base["AuraId"] = value; }
            }

            public int BaseDamage
            {
                get { return (int)base["BaseDamage"]; }
                set { base["BaseDamage"] = value; }
            }

            public double Hit
            {
                get { return (double)base["Hit"]; }
                set { base["Hit"] = value; }
            }


            public int NumAoe
            {
                get { return (int)base["NumAoe"]; }
                set { base["NumAoe"] = value; }
            }
            public int TurnOn
            {
                get { return (int)base["secondTurnOn"]; }
                set { base["secondTurnOn"] = value; }
            }
            public int TurnToActive
            {
                get { return (int)base["TurnToActive"]; }
                set { base["TurnToActive"] = value; }
            }


            public int FunctionType
            {
                get { return (int)base["FunctionType"]; }
                set { base["FunctionType"] = value; }
            }

            public bool AlwaysFirstMove
            {
                get { return (bool)base["AlwaysFirstMove"]; }
                set { base["AlwaysFirstMove"] = value; }
            }

            public int WeatherTurns
            {
                get { return (int)base["WeatherTurns"]; }
                set { base["WeatherTurns"] = value; }
            }
            public bool SecondAttack
            {
                get { return (bool)base["SecondAttack"]; }
                set { base["SecondAttack"] = value; }
            }
            public int secondBaseDamage
            {
                get { return (int)base["secondBaseDamage"]; }
                set { base["secondBaseDamage"] = value; }
            }
            public int secondAuraId
            {
                get { return (int)base["secondAuraId"]; }
                set { base["secondAuraId"] = value; }
            }
            public double secondHit
            {
                get { return (double)base["secondHit"]; }
                set { base["secondHit"] = value; }
            }
            public int secondTurnToActive
            {
                get { return (int)base["secondTurnToActive"]; }
                set { base["secondTurnToActive"] = value; }
            }
            public int secondFunctionType
            {
                get { return (int)base["secondFunctionType"]; }
                set { base["secondFunctionType"] = value; }
            }
            public int secondTurnOn
            {
                get { return (int)base["secondTurnOn"]; }
                set { base["secondTurnOn"] = value; }
            }

        }


    }



}
