﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data;

namespace MurlocBuddy.DataBase
{
  public  class AuraTable : DataTable
    {

        protected override Type GetRowType()
        {
            return typeof(AuraRow);
        }

        protected override DataRow NewRowFromBuilder(DataRowBuilder builder)
        {
            return new AuraRow(builder);
        }

        public AuraRow FindById(int Id)
        {
            return ((AuraRow)(this.Rows.Find(new object[] {
                            Id})));
        }

        public AuraTable()
        {
            TableName = "PetAura";


             DataColumn Id = new DataColumn
            {
                ColumnName = "Id",
                DataType = typeof(int),   // Default string
                Unique = true,                     // Default false
                AllowDBNull = false,            // Default true
                Caption = "Id"         // Default is constructor value
            };
            Columns.Add(Id);

            PrimaryKey = new DataColumn[] { Id };

            Columns.Add(new DataColumn("Name", typeof(string)));
            Columns.Add(new DataColumn("Effect", typeof(int)));




        }


        public class AuraRow : DataRow
        {
            internal AuraRow(DataRowBuilder builder)
                : base(builder)
            {
                Id = 0;
                Name = String.Empty;
                Effect = 0;
            }

            public int Id
            {
                get { return (int)base["Id"]; }
                set { base["Id"] = value; }
            }

            public string Name
            {
                get { return (string)base["Name"]; }
                set { base["Name"] = value; }
            }

            public int Effect
            {
                get { return (int)base["Effect"]; }
                set { base["Effect"] = value; }
            }



        }




    }
}
