﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;



namespace MurlocBuddy.Objects
{
    public class Ability
    {
        /// <summary>
        /// The ID of the ability
        /// </summary>
        public int id;
        /// <summary>
        /// The name of the ability.
        /// </summary>
        public string name;
        /// <summary>
        /// The full path to the ability's icon.
        /// </summary>                    
        public string icon;
        /// <summary>
        /// The normal cooldown period for the ability.
        /// </summary>
        public int maxCooldown;
        /// <summary>
        /// The ability's description in its pure and unparsed form.
        /// </summary>
        public string unparsedDescription;
        /// <summary>
        /// Duration of the ability. This is typically 1, but some abilities last multiple rounds.
        /// </summary>
        public int numTurns;
        /// <summary>
        /// Values are 1-10, based on the pet's type.
        /// </summary>
        public int petType;
        /// <summary>
        /// True if the ability should not show Strong/Weak indicators, false otherwise.
        /// </summary>
        public bool noStrongWeakHints;

        public bool isUsable;

        public int spellIndex;


        public Ability() { }


        public Ability(int petOwner, int petIndex, int abilityIndex)
        {
            List<string> lAbility = MLua.C_PetBattles.GetAbilityInfo(petOwner, petIndex, abilityIndex);
            id = Convert.ToInt32(lAbility[0]);
            name = lAbility[1];
            icon = lAbility[2];
            maxCooldown = Convert.ToInt32(lAbility[3]);
            unparsedDescription = lAbility[4];
            numTurns = Convert.ToInt32(lAbility[5]);
            petType = Convert.ToInt32(lAbility[6]);

            noStrongWeakHints = Convert.ToBoolean(Convert.ToInt32(lAbility[7])); //Need check!!!

            isUsable = MLua.C_PetBattles.GetAbilityState(petOwner, petIndex, abilityIndex);


        }
    }
}
